#
# spec file for package suitesparse
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           suitesparse
Summary:        A collection of sparse matrix libraries
License:        GPL-2.0+ and LGPL-2.1+
Group:          Development/Libraries
Version:        4.4.5
Release:        20.4
Url:            http://www.cise.ufl.edu/research/sparse/SuiteSparse
Source:         SuiteSparse-%{version}.tar.gz
Source2:        %{name}-rpmlintrc
Patch0:         no-removal-of-suitesparse_config-output.patch
Patch1:         blas-instead-of-openblas-SuiteSparse_config_mk.patch
Patch775418:    bnc775418-enable-SuiteSparse_time-symbol.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  blas-devel
BuildRequires:  gcc-c++
BuildRequires:  gcc-fortran
BuildRequires:  lapack-devel
%define amdver      2.4.1
%define amdso       2_4_1
%define btfver      1.2.1
%define btfso       1_2_1
%define camdver     2.4.1
%define camdso      2_4_1
%define ccolamdver  2.9.1
%define ccolamdso   2_9_1
%define colamdver   2.9.1
%define colamdso    2_9_1
%define cholmodver  3.0.6
%define cholmodso   3_0_6
%define csparsever  3.1.4
%define csparseso   3_1_4
%define cxsparsever 3.1.4
%define cxsparseso  3_1_4
%define kluver      1.3.3
%define kluso       1_3_3
%define ldlver      2.2.1
%define ldlso       2_2_1
%define rbiover     2.2.1
%define rbioso      2_2_1
%define spqrver     2.0.1
%define spqrso      2_0_1
%define umfpackver  5.7.1
%define umfpackso   5_7_1
# Your need define even it's just the same as main package
# or the %%build loop will override %%version with umfpack's version.
%define configver   4.4.5
%define configso    4_4_5
%define amdlib      libamd-%{amdso}
%define btflib      libbtf-%{btfso}
%define camdlib     libcamd-%{camdso}
%define ccolamdlib  libccolamd-%{ccolamdso}
%define cholmodlib  libcholmod-%{cholmodso}
%define colamdlib   libcolamd-%{colamdso}
%define csparselib  libcsparsever-%{csparseso}
%define cxsparselib libcxsparse-%{cxsparseso}
%define klulib      libklu-%{kluso}
%define ldllib      libldl-%{ldlso}
%define rbiolib     librbio-%{rbioso}
%define spqrlib     libspqr-%{spqrso}
%define umfpacklib  libumfpack-%{umfpackso}
%define configlib   libsuitesparseconfig-%{configso}

%description
suitesparse is a collection of libraries for computations involving sparse
matrices.

%package devel 
Summary:        Development headers for SuiteSparse
License:        GPL-2.0+ and LGPL-2.1+
Group:          Development/Libraries
Requires:       %{amdlib}      = %{amdver}
Requires:       %{btflib}      = %{btfver}
Requires:       %{camdlib}     = %{camdver}
Requires:       %{ccolamdlib}  = %{ccolamdver}
Requires:       %{cholmodlib}  = %{cholmodver}
Requires:       %{colamdlib}   = %{colamdver}
Requires:       %{configlib}   = %{configver}
Requires:       %{configlib}   = %{version}
Requires:       %{csparselib}  = %{csparsever}
Requires:       %{cxsparselib} = %{cxsparsever}
Requires:       %{klulib}      = %{kluver}
Requires:       %{ldllib}      = %{ldlver}
Requires:       %{rbiolib}     = %{rbiover}
Requires:       %{spqrlib}     = %{spqrver}
Requires:       %{umfpacklib}  = %{umfpackver}
# make sure developers can find these packages
Provides:       suitesparse-common-devel = %{version}
Obsoletes:      suitesparse-common-devel < %{version}
Provides:       SuiteSparse_config       = %{version}
Obsoletes:      SuiteSparse_config       < %{version}
Provides:       amd-devel         = %{amdver}
Obsoletes:      amd-devel         < %{amdver}
Provides:       umfpack-devel     = %{umfpackver}
Obsoletes:      umfpack-devel     < %{umfpackver}
Provides:       libamd-devel      = %{amdver}
Obsoletes:      libamd-devel      < %{amdver}
Provides:       libbtf-devel      = %{btfver}
Obsoletes:      libbtf-devel      < %{btfver}
Provides:       libcamd-devel     = %{camdver}
Obsoletes:      libcamd-devel     < %{camdver}
Provides:       libccolamd-devel  = %{ccolamdver}
Obsoletes:      libccolamd-devel  < %{ccolamdver}
Provides:       libcholmod-devel  = %{cholmodver}
Obsoletes:      libcholmod-devel  < %{cholmodver}
Provides:       libcolamd-devel   = %{colamdver}
Obsoletes:      libcolamd-devel   < %{colamdver}
Provides:       libcsparse-devel  = %{csparsever}
Obsoletes:      libcsparse-devel  < %{csparsever}
Provides:       libcxsparse-devel = %{cxsparsever}
Obsoletes:      libcxsparse-devel < %{cxsparsever}
Provides:       libklu-devel      = %{kluver}
Obsoletes:      libklu-devel      < %{kluver}
Provides:       libldl-devel      = %{ldlver}
Obsoletes:      libldl-devel      < %{ldlver}
Provides:       librbio-devel     = %{rbiover}
Obsoletes:      librbio-devel     < %{rbiover}
Provides:       libspqr-devel     = %{spqrver}
Obsoletes:      libspqr-devel     < %{spqrver}
Provides:       libumfpack-devel  = %{umfpackver}
Obsoletes:      libumfpack-devel  < %{umfpackver}
Provides:       libsuitesparseconfig-devel = %{configver}
Obsoletes:      libsuitesparseconfig-devel < %{configver}
Provides:       UFconfig-devel    = %{configver}
Obsoletes:      UFconfig-devel    < %{configver}

%description devel
suitesparse is a collection of libraries for computations involving 
sparse matrices.

The suitesparse-devel package contains files needed for developing
applications which use the suitesparse libraries.

It also includes SuiteSparse_config, which is required by nearly all 
sparse matrix packages that I author or co-author. These include 
SuiteSparseQR, AMD, COLAMD, CCOLAMD, CHOLMOD, KLU, BTF, LDL, 
CXSparse, RBio, and UMFPACK. It is not required by CSparse, which is 
a stand-alone package. SuiteSparse_config (prior to version 4.0.0) 
was named UFconfig.

SuiteSparse_config contains a configuration file for "make" 
(SuiteSparse_config.mk) and an include file (SuiteSparse_config.h). 
Also included in SuiteSparse_config is a replacement for the 
BLAS/LAPACK xerbla routine that does not print a warning message 
(helpful if you don't want to link the entire Fortran I/O library 
into a C application).

%package devel-static
Summary:        Static version of SuiteSparse libraries
License:        GPL-2.0+ and LGPL-2.1+
Group:          Development/Libraries
Requires:       %{name}-devel = %{version}

%description devel-static
The suitesparse-static package contains the statically linkable
version of the suitesparse libraries.

%package -n %{amdlib}
Version:        %{amdver}
Release:        20.4
Summary:        Symmetric Approximate Minimum Degree
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{amdlib}
AMD is a set of routines for ordering a sparse matrix prior to 
Cholesky factorization (or for LU factorization with diagonal 
pivoting). There are versions in both C and Fortran. A MATLAB 
interface is provided.

Note that this software has nothing to do with AMD the company.

AMD is part of the SuiteSparse sparse matrix suite.

%package -n %{btflib}
Version:        %{btfver}
Release:        20.4
Summary:        Permutation to Block Triangular Form
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{btflib}
BTF permutes an unsymmetric matrix (square or rectangular) into its 
block upper triangular form (more precisely, it computes a Dulmage-
Mendelsohn decomposition).

BTF is part of the SuiteSparse sparse matrix suite.

%package -n %{camdlib}
Version:        %{camdver}
Release:        20.4
Summary:        Symmetric Approximate Minimum Degree
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{camdlib}
CAMD is a set of routines for ordering a sparse matrix prior to 
Cholesky factorization (or for LU factorization with diagonal 
pivoting). There are versions in both C and Fortran. A MATLAB 
interface is provided.

CAMD is part of the SuiteSparse sparse matrix suite.

%package -n %{ccolamdlib}
Version:        %{ccolamdver}
Release:        20.4
Summary:        Constrained Column Approximate Minimum Degree
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{ccolamdlib}
CCOLAMD computes an column approximate minimum degree ordering 
algorithm, (like COLAMD), but it can also be given a set of ordering
constraints. CCOLAMD is required by the CHOLMOD package.

CCOLAMD is part of the SuiteSparse sparse matrix suite.

%package -n %{cholmodlib}
Version:        %{cholmodver}
Release:        20.4
Summary:        Supernodal Sparse Cholesky Factorization and Update/Downdate
License:        GPL-2.0 and LGPL-2.1
Group:          Development/Libraries
#bnc746867 cholmod from suitesparse should be GPL-2.0 and/or LGPL-2.0 licensed

%description -n %{cholmodlib}
CHOLMOD is a set of ANSI C routines for sparse Cholesky factorization
and update/downdate. A MATLAB interface is provided.

The performance of CHOLMOD was compared with 10 other codes in a 
paper by Nick Gould, Yifan Hu, and Jennifer Scott. see also their raw
data. Comparing BCSLIB-EXT, CHOLMOD, MA57, MUMPS, Oblio, PARDISO, 
SPOOLES, SPRSBLKLLT, TAUCS, UMFPACK, and WSMP, on 87 large symmetric 
positive definite matrices, they found CHOLMOD to be fastest for 42 
of the 87 matrices. Its run time is either fastest or within 10% of 
the fastest for 73 out of 87 matrices. Considering just the larger 
matrices, it is either the fastest or within 10% of the fastest for 
40 out of 42 matrices. It uses the least amount of memory (or within 
10% of the least) for 35 of the 42 larger matrices. Jennifer Scott 
and Yifan Hu also discuss the design considerations for a sparse 
direct code. 

CHOLMOD is part of the SuiteSparse sparse matrix suite.

%package -n %{colamdlib}
Version:        %{colamdver}
Release:        20.4
Summary:        Column Approximate Minimum Degree
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{colamdlib}
The COLAMD column approximate minimum degree ordering algorithm
computes a permutation vector P such that the LU factorization of
A (:,P) tends to be sparser than that of A. The Cholesky
factorization of (A (:,P))'*(A (:,P)) will also tend to be sparser
than that of A'*A. SYMAMD is a symmetric minimum degree ordering 
method based on COLAMD, available as a MATLAB-callable function. It
constructs a matrix M such that M'*M has the same pattern as A, and
then uses COLAMD to compute a column ordering of M. Colamd and symamd
tend to be faster and generate better orderings than their MATLAB
counterparts, colmmd and symmmd. 

COLAMD is part of the SuiteSparse sparse matrix suite.

%package -n %{csparselib}
Version:        %{csparsever}
Release:        20.4
Summary:        Instructional Sparse Matrix Package
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{csparselib}
CSparse is a small yet feature-rich sparse matrix package written
specifically for a book. The purpose of the package is to demonstrate
a wide range of sparse matrix algorithms in as concise a code as
possible. CSparse is about 2,200 lines long (excluding its MATLAB
interface, demo codes, and test codes), yet it contains algorithms 
(either asympotical optimal or fast in practice) for all of the 
following functions described below. A MATLAB interface is included. 

Note that the LU and Cholesky factorization algorithms are not as
fast as UMFPACK or CHOLMOD. Other functions have comparable
performance as their MATLAB equivalents (some are faster). 

Documentation is very terse in the code; it is fully documented in
the book. Some indication of how to call the C functions in CSparse
is given by the CSparse/MATLAB/*.m help files. 

CSparse is part of the SuiteSparse sparse matrix suite.

%package -n %{cxsparselib}
Version:        %{cxsparsever}
Release:        20.4
Summary:        An extended version of CSparse
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{cxsparselib}
CXSparse is an extended version of CSparse, with support for double
or complex matrices, with int or long integers.

CXSparse is part of the SuiteSparse sparse matrix suite.

%package -n %{klulib}
Version:        %{kluver}
Release:        20.4
Summary:        Sparse LU Factorization, for Circuit Simulation
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{klulib}
KLU is a sparse LU factorization algorithm well-suited for use in
circuit simulation. It was highlighted in the May 2007 issue of SIAM
News, Sparse Matrix Algorithm Drives SPICE Performance Gains. It is
the "fast sparse-matrix solver" mentioned in the article.

KLU is part of the SuiteSparse sparse matrix suite.

%package -n %{ldllib}
Version:        %{ldlver}
Release:        20.4
Summary:        A Simple LDL^T Factorization
License:        LGPL-2.1+
Group:          Development/Libraries

%description -n %{ldllib}
LDL is a set of concise routines for factorizing symmetric positive-
definite sparse matrices, with some applicability to symmetric 
indefinite matrices. Its primary purpose is to illustrate much of the
basic theory of sparse matrix algorithms in as concise a code as 
possible, including an elegant new method of sparse symmetric 
factorization that computes the factorization row-by-row but stores 
it column-by-column. The entire symbolic and numeric factorization 
consists of a total of only 49 lines of code. The package is written 
in C, and includes a MATLAB interface. 

LDL is part of the SuiteSparse sparse matrix suite.

%package -n %{rbiolib}
Version:        %{rbiover}
Release:        20.4
Summary:        MATLAB Toolbox for Reading/Writing Sparse Matrices
License:        GPL-2.0+
Group:          Development/Libraries

%description -n %{rbiolib}
RBio is a MATLAB toolbox for reading/writing sparse matrices in the 
Rutherford/Boeing format, and for reading/writing problems in the UF 
Sparse Matrix Collection from/to a set of files in a directory. 
Version 2.0+ is written in C. 

RBio is part of the SuiteSparse sparse matrix suite.

%package -n %{spqrlib}
Version:        %{spqrver}
Release:        20.4
Summary:        Multifrontal Sparse QR
License:        GPL-2.0+
Group:          Development/Libraries

%description -n %{spqrlib}
SuiteSparseQR is an implementation of the multifrontal sparse QR 
factorization method. Parallelism is exploited both in the BLAS and 
across different frontal matrices using Intel's Threading Building 
Blocks, a shared-memory programming model for modern multicore 
architectures. It can obtain a substantial fraction of the 
theoretical peak performance of a multicore computer. The package is 
written in C++ with user interfaces for MATLAB, C, and C++. 

SuiteSparseQR is part of the SuiteSparse sparse matrix suite.

%package -n %{umfpacklib}
Version:        %{umfpackver}
Release:        20.4
Summary:        Sparse Multifrontal LU Factorization
License:        GPL-2.0+
Group:          Development/Libraries

%description -n %{umfpacklib}
UMFPACK is a set of routines for solving unsymmetric sparse linear 
systems, Ax=b, using the Unsymmetric MultiFrontal method. Written in 
ANSI/ISO C, with a MATLAB (Version 6.0 and later) interface. Appears 
as a built-in routine (for lu, backslash, and forward slash) in M
ATLAB. Includes a MATLAB interface, a C-callable interface, and a 
Fortran-callable interface. Note that "UMFPACK" is pronounced in two 
syllables, "Umph Pack". It is not "You Em Ef Pack". 

UMFPACK is part of the SuiteSparse sparse matrix suite.

%package -n %{configlib}
Version:        %{configver}
Release:        20.4
Summary:        Common configurations for all packages in SuiteSparse
License:        GPL-2.0+
Group:          Development/Libraries
Provides:       libufconfig = %{configver}
Obsoletes:      libufconfig < %{configver}
Provides:       libUFconfig = %{configver}
Obsoletes:      libUFconfig < %{configver}

%description -n %{configlib}
SuiteSparse_config is required by nearly all sparse matrix packages that I author or co-author. These include SuiteSparseQR, AMD, COLAMD, CCOLAMD, CHOLMOD, KLU, BTF, LDL, CXSparse, RBio, and UMFPACK. It is not required by CSparse, which is a stand-alone package. SuiteSparse_config (prior to version 4.0.0) was named UFconfig.
SuiteSparse_config contains a configuration file for "make" (SuiteSparse_config.mk) and an include file (SuiteSparse_config.h). Also included in SuiteSparse_config is a replacement for the BLAS/LAPACK xerbla routine that does not print a warning message (helpful if you don't want to link the entire Fortran I/O library into a C application).

SuiteSparse_config is part of the SuiteSparse sparse matrix suite.

%prep
%setup -q -n SuiteSparse
sed 's/^CHOLMOD_CONFIG =.*/CHOLMOD_CONFIG = -DNPARTITION/' -i SuiteSparse_config/SuiteSparse_config.mk
sed 's/^\(METIS =\).*//' -i SuiteSparse_config/SuiteSparse_config.mk

# bnc#751746
rm -rf MATLAB_Tools/Factorize/Doc/factorize_article.pdf
rm -rf SPQR/Doc/algo_spqr.pdf
rm -rf SPQR/Doc/spqr.pdf
# bnc#775418
%patch0 -p1
%patch1 -p1
%patch775418 -p1

%build
mkdir -p Lib

#bnc775418 provides SuiteSparse_time symbol in SuiteSparse_config
pushd SuiteSparse_config
  make CFLAGS="%{optflags} -fPIC"
  pushd ../Lib
  gcc -shared -Wl,-soname -Wl,"libsuitesparseconfig-%{configver}.so" -o "libsuitesparseconfig-%{configver}.so" ../SuiteSparse_config/*.o -lm
  ln -s "libsuitesparseconfig-%{version}.so" "libsuitesparseconfig.so"
  popd
popd

# libraries linking config [bnc#883683]
amd_libs="libsuitesparseconfig.so"
camd_libs="libsuitesparseconfig.so"
ccolamd_libs="libsuitesparseconfig.so"
cholmod_libs="libamd.so libcamd.so libcolamd.so libccolamd.so libsuitesparseconfig.so -lblas -llapack"
colamd_libs="libsuitesparseconfig.so"
klu_libs="libamd.so libbtf.so libcolamd.so"
rbio_libs="libsuitesparseconfig.so"
spqr_libs="libcholmod.so libsuitesparseconfig.so -lblas -llapack"
umfpack_libs="libamd.so libcholmod.so libsuitesparseconfig.so -lblas -llapack"

for dir in AMD BTF CAMD CCOLAMD COLAMD CHOLMOD CSparse CXSparse KLU LDL RBio SPQR UMFPACK; do
    pushd $dir
      ver=$(grep -E "^VERSION =" Makefile | sed "s:VERSION = ::")
      make CFLAGS="%{optflags} -fPIC"
    popd
    pushd Lib
      dir_l=$(echo "$dir" | tr "[A-Z]" "[a-z]")
      linked_libs=${dir_l}_libs
      gcc -shared -Wl,-soname -Wl,"lib${dir_l}-$ver.so" -o "lib${dir_l}-$ver.so" ../${dir}/Lib/*.o ${!linked_libs} -lm
      ln -s "lib${dir_l}-$ver.so" "lib${dir_l}.so"
    popd
done

# specialities
# -- CHOLMOD
pushd CHOLMOD
  cp Cholesky/License.txt Doc/Cholesky_License.txt
  cp Core/License.txt Doc/Core_License.txt
  cp MatrixOps/License.txt Doc/MatrixOps_License.txt
  cp Partition/License.txt Doc/Partition_License.txt
  cp Supernodal/License.txt Doc/Supernodal_License.txt
popd

%install
mkdir -p %{buildroot}%{_includedir}/%{name}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_docdir}/%{name}
mkdir -p %{buildroot}%{_docdir}/%{name}-devel
cp -a SuiteSparse_config/SuiteSparse_config.h %{buildroot}%{_includedir}/%{name}
cp -a README.txt %{buildroot}%{_docdir}/%{name}
cp -a Lib/*.so* %{buildroot}/%{_libdir}
for dir in AMD BTF CAMD CCOLAMD CHOLMOD COLAMD CSparse CXSparse KLU LDL RBio SPQR UMFPACK; do
    pushd $dir
      ver=$(grep -E "^VERSION =" Makefile | sed "s:VERSION = ::")
      cp -a Lib/*.a %{buildroot}/%{_libdir}
      cp -a Include/*.h  %{buildroot}%{_includedir}/%{name}
      mkdir %{buildroot}%{_docdir}/%{name}/$dir-$ver
      mkdir %{buildroot}%{_docdir}/%{name}-devel/$dir
      cp -a README.txt Doc/{License,ChangeLog,*.txt} %{buildroot}%{_docdir}/%{name}/$dir-$ver > /dev/null 2>&1 | true
      cp -a $dir/Doc/*.pdf %{buildroot}%{_docdir}/%{name}-devel/$dir > /dev/null 2>&1 | true
    popd
done

cp -r SuiteSparse_config/*.a %{buildroot}%{_libdir}
mkdir %{buildroot}%{_docdir}/%{name}/SuiteSparse_config-%{configver}/
cp -r SuiteSparse_config/README.txt %{buildroot}%{_docdir}/%{name}/SuiteSparse_config-%{configver}/

%check
amd_test_symbol="amd_postorder"
btf_test_symbol="btf_order"
camd_test_symbol="camd_postorder"
ccolamd_test_symbol="ccolamd"
colamd_test_symbol="colamd"
cholmod_test_symbol="cholmod_start"
csparse_test_symbol="cs_sqr"
cxsparse_test_symbol="cs_di_sqr"
klu_test_symbol="klu_solve"
ldl_test_symbol="ldl_symbolic"
rbio_test_symbol="RBread"
spqr_test_symbol="SuiteSparseQR_C_symbolic"
umfpack_test_symbol="umfpack_toc"

mkdir -p linking_test
pushd linking_test

cat > linking_test.c.in << 'EOF'
char @test_symbol@ ();
int main ()
{
    return @test_symbol@ ();
}
EOF

export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:%{buildroot}%{_libdir}
for test_library in amd btf camd ccolamd colamd cholmod csparse cxsparse klu ldl rbio spqr umfpack; do
    cp linking_test.c.in linking_test.c
    test_symbol=${test_library}_test_symbol
    sed -i "s|@test_symbol@|${!test_symbol}|" linking_test.c
    gcc -o linking_test linking_test.c -L%{buildroot}%{_libdir} -l${test_library}
done

popd

%post   -n %{amdlib} -p /sbin/ldconfig
%postun -n %{amdlib} -p /sbin/ldconfig

%post   -n %{btflib} -p /sbin/ldconfig
%postun -n %{btflib} -p /sbin/ldconfig

%post   -n %{camdlib} -p /sbin/ldconfig
%postun -n %{camdlib} -p /sbin/ldconfig

%post   -n %{ccolamdlib} -p /sbin/ldconfig
%postun -n %{ccolamdlib} -p /sbin/ldconfig

%post   -n %{cholmodlib} -p /sbin/ldconfig
%postun -n %{cholmodlib} -p /sbin/ldconfig

%post   -n %{colamdlib} -p /sbin/ldconfig
%postun -n %{colamdlib} -p /sbin/ldconfig

%post   -n %{csparselib} -p /sbin/ldconfig
%postun -n %{csparselib} -p /sbin/ldconfig

%post   -n %{cxsparselib} -p /sbin/ldconfig
%postun -n %{cxsparselib} -p /sbin/ldconfig

%post   -n %{klulib} -p /sbin/ldconfig
%postun -n %{klulib} -p /sbin/ldconfig

%post   -n %{ldllib} -p /sbin/ldconfig
%postun -n %{ldllib} -p /sbin/ldconfig

%post   -n %{rbiolib} -p /sbin/ldconfig
%postun -n %{rbiolib} -p /sbin/ldconfig

%post   -n %{spqrlib} -p /sbin/ldconfig
%postun -n %{spqrlib} -p /sbin/ldconfig

%post   -n %{umfpacklib} -p /sbin/ldconfig
%postun -n %{umfpacklib} -p /sbin/ldconfig

%post   -n %{configlib} -p /sbin/ldconfig
%postun -n %{configlib} -p /sbin/ldconfig

%files devel
%defattr(-,root,root)
%{_includedir}/%{name}
%{_libdir}/lib*.so
%exclude %{_libdir}/lib*-*.so
%{_docdir}/%{name}-devel
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/README.txt

%files devel-static
%defattr(-,root,root)
%{_libdir}/lib*.a

%files -n %{amdlib}
%defattr(-, root, root)
%{_libdir}/libamd-%{amdver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/AMD-%{amdver}

%files -n %{btflib}
%defattr(-, root, root)
%{_libdir}/libbtf-%{btfver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/BTF-%{btfver}

%files -n %{camdlib}
%defattr(-, root, root)
%{_libdir}/libcamd-%{camdver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/CAMD-%{camdver}

%files -n %{ccolamdlib}
%defattr(-, root, root)
%{_libdir}/libccolamd-%{ccolamdver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/CCOLAMD-%{ccolamdver}

%files -n %{cholmodlib}
%defattr(-, root, root)
%{_libdir}/libcholmod-%{cholmodver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/CHOLMOD-%{cholmodver}

%files -n %{colamdlib}
%defattr(-, root, root)
%{_libdir}/libcolamd-%{colamdver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/COLAMD-%{colamdver}

%files -n %{csparselib}
%defattr(-, root, root)
%{_libdir}/libcsparse-%{csparsever}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/CSparse-%{csparsever}

%files -n %{cxsparselib}
%defattr(-, root, root)
%{_libdir}/libcxsparse-%{cxsparsever}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/CXSparse-%{cxsparsever}

%files -n %{klulib}
%defattr(-, root, root)
%{_libdir}/libklu-%{kluver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/KLU-%{kluver}

%files -n %{ldllib}
%defattr(-, root, root)
%{_libdir}/libldl-%{ldlver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/LDL-%{ldlver}

%files -n %{rbiolib}
%defattr(-, root, root)
%{_libdir}/librbio-%{rbiover}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/RBio-%{rbiover}

%files -n %{spqrlib}
%defattr(-, root, root)
%{_libdir}/libspqr-%{spqrver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/SPQR-%{spqrver}

%files -n %{umfpacklib}
%defattr(-, root, root)
%{_libdir}/libumfpack-%{umfpackver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/UMFPACK-%{umfpackver}

%files -n %{configlib}
%defattr(-,root,root)
%{_libdir}/libsuitesparseconfig-%{configver}.so
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/SuiteSparse_config-%{configver}

%changelog
* Wed Sep 23 2015 foss@grueninger.de
- Update to version 4.4.5
  + CHOLMOD 3.0.6:
  * minor fix to CHOLMOD (-DNGPL did not work as expected)
  * added MATLAB interface for row add/delete (lurowmod)
  + KLU 1.3.3: Fix for klu_dump.c (debugging case only)
  + UFcollection:  added additional stats for matrix collection
  + AMD: changed the license.  Was LGPL only, now either LGPL or BSD,
    at the user's option.  See AMD/Doc/License.txt for details.
* Wed Apr  1 2015 foss@grueninger.de
- Update to version 4.4.4
  + CHOLMOD version number corrected.  In 4.4.3, the CHOLMOD_SUBSUB_VERSION
    string was left at '4' (it should have been '5', for CHOLMOD 3.0.5).
    This version of SuiteSparse corrects this glitch.
  + Minor changes to comments in SuiteSparse_config.
  + SPQR version 2.0.1 released (minor update to documentation)
* Tue Jan 27 2015 dmitry_r@opensuse.org
- Fix linking config
- Add linking tests
* Tue Jan 20 2015 foss@grueninger.de
- Update to version 4.4.3
  + CHOLMOD 3.0.5: minor bug fix to MatrixOps/cholmod_symmetry
- Update to version 4.4.2
  + CHOLMOD 3.0.4: serious bug fix in supernodal factorization,
  introduced in CHOLMOD 3.0.0 (SuiteSparse 4.3.0).  Can cause segfault,
  and has no user workaround.
- Upstream SuiteSparse preferes OpenBLAS, added patch
    blas-instead-of-openblas-SuiteSparse_config_mk.patch
  to use BLAS as SuiteSparse 4.4.1 did
* Mon Nov 10 2014 foss@grueninger.de
- Update to version 4.4.1
  + Minor update:  two bug fixes (affecting Windows only) for
    CHOLMOD and KLU
* Wed Oct 22 2014 foss@grueninger.de
- Update to version 4.4.0
  + (added GPU acceleration to CHOLMOD and SPQR.  Up to 10x faster
    than a multicore CPU.) Not yet working in the package
  + changed to a consistent method for all of SuiteSparse, for
    malloc/calloc/realloc, and printf, using SuiteSparse_config.
* Sun Jun 22 2014 dmitry_r@opensuse.org
- Fix libraries linking [bnc#883683]
* Sun Nov 10 2013 p.drouand@gmail.com
- Update to version 4.2.1
  + no changelog available
- Fix Groups to respect new standards
* Fri Nov  2 2012 jengelh@inai.de
- shlib naming: libsuitesparseconfig-4_0_2, not -4.0.2
* Thu Aug 23 2012 Rene.vanPaassen@gmail.com
- need to escape %% in comments -- Fedora builds choked on them
* Thu Aug 16 2012 i@marguerite.su
- also re-fix bnc#746867:
  * cholmod from suitesparse should be GPL-2.0 and/or LGPL-2.0 licensed
* Wed Aug 15 2012 i@marguerite.su
- fix bnc#775418: SuiteSparse does not ship library which contains
  the symbol SuiteSparse_time
  * it's because latest SuiteSparse prefers NTIMER.(try to depreciate)
    so when there's NTIMER avaiable, tic/toc will not be enabled.
  * easy solution is to use "-lSuiteSparse" in the UMFPACK_LIBS
    variable in the affected packages like Octave.
  * but this seems to affect many packages in science repo, so I
    just add a patch comment #IF NTIMER off.
  * http://comments.gmane.org/gmane.comp.gnu.octave.general/42837
- add sub-package libsuitesparse_config which is formly known as UFconfig.
  * also add provides/obsoltes of UFconfig.
  * add patch0 to prevent removal of .o after .a is built.
    we still need .o to make shared libsuitesparseconfig.so
* Tue Jul 31 2012 i@marguerite.su
- Update to version 4.0.2
  * no changelog available.
* Wed Jun  6 2012 i@marguerite.su
- fix bnc#751746.
* Mon Jun  4 2012 toddrme2178@gmail.com
- Update to version 4.0.0. Major changes:
  * added GPU support for CHOLMOD
  * Renamed UFconfig to SuiteSparse_config
- Fix licenses (some libraries are LGPL-2.1+, some are GPL-2.0+,
  and one is both).
- Change descriptions to upstream versions
- Build csparse package
- Clean up spec file
  * Remove hard-coded library versions everywhere.  Each library
    version only needs to be changed in two places, which are right
    next to each other
- Move README to -devel package and remove now-empty base package
- Changed group to match lapack/blas group (which this package is
  essentially an extension of)
* Sun Feb 19 2012 i@marguerite.su
- fix timestamp error in changelog, dont know why it omit zero in
  time format.
* Sat Feb 18 2012 jengelh@medozas.de
- add rpmlintrc to shut up false positives (after inquiry by
  MargueriteSu)
* Fri Feb 17 2012 i@marguerite.su
- fix libraries version tags of suitesparse-devel requires.
* Wed Feb 15 2012 i@marguerite.su
- fix bug#746867. cholmod is licensed under GPL-2.0 and LGPL-2.0 only,
  GPL-2.0 only prevents other components to be licensed under a high
  version of the same license.
* Tue Feb  7 2012 jengelh@medozas.de
- Apply shared library policy
  http://en.opensuse.org/openSUSE:Shared_library_packaging_policy
* Sat Feb  4 2012 i@marguerite.su
- update to version 3.7.0
* Wed Dec 21 2011 coyoteuser@gmail.com
- updated to latest version 3.2.0
- added gcc4.3.2 fix for spqr.hpp
- changed source to bz2 archive
* Mon Dec  8 2008 coyoyeuser@gmail.com
- Initial release
